diff --git a/src/backend/replication/logical/snapbuild.c b/src/backend/replication/logical/snapbuild.c
index fba57a0470..580d45b252 100644
--- a/src/backend/replication/logical/snapbuild.c
+++ b/src/backend/replication/logical/snapbuild.c
@@ -164,17 +164,15 @@ struct SnapBuild
 	/* all transactions >= than this are uncommitted */
 	TransactionId xmax;
 
+	/* this determines the state of transactions between xmin and xmax */
+	CommitSeqNo snapshotcsn;
+
 	/*
 	 * Don't replay commits from an LSN < this LSN. This can be set externally
 	 * but it will also be advanced (never retreat) from within snapbuild.c.
 	 */
 	XLogRecPtr	start_decoding_at;
 
-	/*
-	 * Don't start decoding WAL until the "xl_running_xacts" information
-	 * indicates there are no running xids with an xid smaller than this.
-	 */
-	TransactionId initial_xmin_horizon;
 
 	/* Indicates if we are building full snapshot or just catalog one. */
 	bool		building_full_snapshot;
@@ -185,70 +183,9 @@ struct SnapBuild
 	Snapshot	snapshot;
 
 	/*
-	 * LSN of the last location we are sure a snapshot has been serialized to.
-	 */
-	XLogRecPtr	last_serialized_snapshot;
-
-	/*
 	 * The reorderbuffer we need to update with usable snapshots et al.
 	 */
 	ReorderBuffer *reorder;
-
-	/*
-	 * Outdated: This struct isn't used for its original purpose anymore, but
-	 * can't be removed / changed in a minor version, because it's stored
-	 * on-disk.
-	 */
-	struct
-	{
-		/*
-		 * NB: This field is misused, until a major version can break on-disk
-		 * compatibility. See SnapBuildNextPhaseAt() /
-		 * SnapBuildStartNextPhaseAt().
-		 */
-		TransactionId was_xmin;
-		TransactionId was_xmax;
-
-		size_t		was_xcnt;	/* number of used xip entries */
-		size_t		was_xcnt_space; /* allocated size of xip */
-		TransactionId *was_xip; /* running xacts array, xidComparator-sorted */
-	}			was_running;
-
-	/*
-	 * Array of transactions which could have catalog changes that committed
-	 * between xmin and xmax.
-	 */
-	struct
-	{
-		/* number of committed transactions */
-		size_t		xcnt;
-
-		/* available space for committed transactions */
-		size_t		xcnt_space;
-
-		/*
-		 * Until we reach a CONSISTENT state, we record commits of all
-		 * transactions, not just the catalog changing ones. Record when that
-		 * changes so we know we cannot export a snapshot safely anymore.
-		 */
-		bool		includes_all_transactions;
-
-		/*
-		 * Array of committed transactions that have modified the catalog.
-		 *
-		 * As this array is frequently modified we do *not* keep it in
-		 * xidComparator order. Instead we sort the array when building &
-		 * distributing a snapshot.
-		 *
-		 * TODO: It's unclear whether that reasoning has much merit. Every
-		 * time we add something here after becoming consistent will also
-		 * require distributing a snapshot. Storing them sorted would
-		 * potentially also make it easier to purge (but more complicated wrt
-		 * wraparound?). Should be improved if sorting while building the
-		 * snapshot shows up in profiles.
-		 */
-		TransactionId *xip;
-	}			committed;
 };
 
 /*
@@ -258,9 +195,6 @@ struct SnapBuild
 static ResourceOwner SavedResourceOwnerDuringExport = NULL;
 static bool ExportInProgress = false;
 
-/* ->committed manipulation */
-static void SnapBuildPurgeCommittedTxn(SnapBuild *builder);
-
 /* snapshot building/manipulation/distribution functions */
 static Snapshot SnapBuildBuildSnapshot(SnapBuild *builder);
 
@@ -270,41 +204,6 @@ static void SnapBuildSnapIncRefcount(Snapshot snap);
 
 static void SnapBuildDistributeNewCatalogSnapshot(SnapBuild *builder, XLogRecPtr lsn);
 
-/* xlog reading helper functions for SnapBuildProcessRecord */
-static bool SnapBuildFindSnapshot(SnapBuild *builder, XLogRecPtr lsn, xl_running_xacts *running);
-static void SnapBuildWaitSnapshot(xl_running_xacts *running, TransactionId cutoff);
-
-/* serialization functions */
-static void SnapBuildSerialize(SnapBuild *builder, XLogRecPtr lsn);
-static bool SnapBuildRestore(SnapBuild *builder, XLogRecPtr lsn);
-
-/*
- * Return TransactionId after which the next phase of initial snapshot
- * building will happen.
- */
-static inline TransactionId
-SnapBuildNextPhaseAt(SnapBuild *builder)
-{
-	/*
-	 * For backward compatibility reasons this has to be stored in the wrongly
-	 * named field.  Will be fixed in next major version.
-	 */
-	return builder->was_running.was_xmax;
-}
-
-/*
- * Set TransactionId after which the next phase of initial snapshot building
- * will happen.
- */
-static inline void
-SnapBuildStartNextPhaseAt(SnapBuild *builder, TransactionId at)
-{
-	/*
-	 * For backward compatibility reasons this has to be stored in the wrongly
-	 * named field.  Will be fixed in next major version.
-	 */
-	builder->was_running.was_xmax = at;
-}
 
 /*
  * Allocate a new snapshot builder.
@@ -314,7 +213,6 @@ SnapBuildStartNextPhaseAt(SnapBuild *builder, TransactionId at)
  */
 SnapBuild *
 AllocateSnapshotBuilder(ReorderBuffer *reorder,
-						TransactionId xmin_horizon,
 						XLogRecPtr start_lsn,
 						bool need_full_snapshot)
 {
@@ -335,13 +233,6 @@ AllocateSnapshotBuilder(ReorderBuffer *reorder,
 	builder->reorder = reorder;
 	/* Other struct members initialized by zeroing via palloc0 above */
 
-	builder->committed.xcnt = 0;
-	builder->committed.xcnt_space = 128;	/* arbitrary number */
-	builder->committed.xip =
-		palloc0(builder->committed.xcnt_space * sizeof(TransactionId));
-	builder->committed.includes_all_transactions = true;
-
-	builder->initial_xmin_horizon = xmin_horizon;
 	builder->start_decoding_at = start_lsn;
 	builder->building_full_snapshot = need_full_snapshot;
 
@@ -380,7 +271,6 @@ SnapBuildFreeSnapshot(Snapshot snap)
 
 	/* make sure nobody modified our snapshot */
 	Assert(snap->curcid == FirstCommandId);
-	Assert(!snap->suboverflowed);
 	Assert(!snap->takenDuringRecovery);
 	Assert(snap->regd_count == 0);
 
@@ -438,7 +328,6 @@ SnapBuildSnapDecRefcount(Snapshot snap)
 
 	/* make sure nobody modified our snapshot */
 	Assert(snap->curcid == FirstCommandId);
-	Assert(!snap->suboverflowed);
 	Assert(!snap->takenDuringRecovery);
 
 	Assert(snap->regd_count == 0);
@@ -468,10 +357,9 @@ SnapBuildBuildSnapshot(SnapBuild *builder)
 	Snapshot	snapshot;
 	Size		ssize;
 
-	Assert(builder->state >= SNAPBUILD_FULL_SNAPSHOT);
+	Assert(builder->state >= SNAPBUILD_CONSISTENT);
 
 	ssize = sizeof(SnapshotData)
-		+ sizeof(TransactionId) * builder->committed.xcnt
 		+ sizeof(TransactionId) * 1 /* toplevel xid */ ;
 
 	snapshot = MemoryContextAllocZero(builder->context, ssize);
@@ -479,52 +367,34 @@ SnapBuildBuildSnapshot(SnapBuild *builder)
 	snapshot->satisfies = HeapTupleSatisfiesHistoricMVCC;
 
 	/*
-	 * We misuse the original meaning of SnapshotData's xip and subxip fields
-	 * to make the more fitting for our needs.
-	 *
-	 * In the 'xip' array we store transactions that have to be treated as
-	 * committed. Since we will only ever look at tuples from transactions
-	 * that have modified the catalog it's more efficient to store those few
-	 * that exist between xmin and xmax (frequently there are none).
-	 *
 	 * Snapshots that are used in transactions that have modified the catalog
-	 * also use the 'subxip' array to store their toplevel xid and all the
+	 * use the 'this_xip' array to store their toplevel xid and all the
 	 * subtransaction xids so we can recognize when we need to treat rows as
-	 * visible that are not in xip but still need to be visible. Subxip only
+	 * visible that would not normally be visible by the CSN test. this_xip only
 	 * gets filled when the transaction is copied into the context of a
 	 * catalog modifying transaction since we otherwise share a snapshot
 	 * between transactions. As long as a txn hasn't modified the catalog it
 	 * doesn't need to treat any uncommitted rows as visible, so there is no
 	 * need for those xids.
 	 *
-	 * Both arrays are qsort'ed so that we can use bsearch() on them.
+	 * this_xip array is qsort'ed so that we can use bsearch() on them.
 	 */
 	Assert(TransactionIdIsNormal(builder->xmin));
 	Assert(TransactionIdIsNormal(builder->xmax));
+	Assert(builder->snapshotcsn != InvalidCommitSeqNo);
 
 	snapshot->xmin = builder->xmin;
 	snapshot->xmax = builder->xmax;
-
-	/* store all transactions to be treated as committed by this snapshot */
-	snapshot->xip =
-		(TransactionId *) ((char *) snapshot + sizeof(SnapshotData));
-	snapshot->xcnt = builder->committed.xcnt;
-	memcpy(snapshot->xip,
-		   builder->committed.xip,
-		   builder->committed.xcnt * sizeof(TransactionId));
-
-	/* sort so we can bsearch() */
-	qsort(snapshot->xip, snapshot->xcnt, sizeof(TransactionId), xidComparator);
+	snapshot->snapshotcsn = builder->snapshotcsn;
 
 	/*
-	 * Initially, subxip is empty, i.e. it's a snapshot to be used by
+	 * Initially, this_xip is empty, i.e. it's a snapshot to be used by
 	 * transactions that don't modify the catalog. Will be filled by
 	 * ReorderBufferCopySnap() if necessary.
 	 */
-	snapshot->subxcnt = 0;
-	snapshot->subxip = NULL;
+	snapshot->this_xcnt = 0;
+	snapshot->this_xip = NULL;
 
-	snapshot->suboverflowed = false;
 	snapshot->takenDuringRecovery = false;
 	snapshot->copied = false;
 	snapshot->curcid = FirstCommandId;
@@ -545,9 +415,6 @@ Snapshot
 SnapBuildInitialSnapshot(SnapBuild *builder)
 {
 	Snapshot	snap;
-	TransactionId xid;
-	TransactionId *newxip;
-	int			newxcnt = 0;
 
 	Assert(!FirstSnapshotSet);
 	Assert(XactIsoLevel == XACT_REPEATABLE_READ);
@@ -555,9 +422,6 @@ SnapBuildInitialSnapshot(SnapBuild *builder)
 	if (builder->state != SNAPBUILD_CONSISTENT)
 		elog(ERROR, "cannot build an initial slot snapshot before reaching a consistent state");
 
-	if (!builder->committed.includes_all_transactions)
-		elog(ERROR, "cannot build an initial slot snapshot, not all transactions are monitored anymore");
-
 	/* so we don't overwrite the existing value */
 	if (TransactionIdIsValid(MyPgXact->xmin))
 		elog(ERROR, "cannot build an initial slot snapshot when MyPgXact->xmin already is valid");
@@ -569,56 +433,7 @@ SnapBuildInitialSnapshot(SnapBuild *builder)
 	 * mechanism. Due to that we can do this without locks, we're only
 	 * changing our own value.
 	 */
-#ifdef USE_ASSERT_CHECKING
-	{
-		TransactionId safeXid;
-
-		LWLockAcquire(ProcArrayLock, LW_SHARED);
-		safeXid = GetOldestSafeDecodingTransactionId(false);
-		LWLockRelease(ProcArrayLock);
-
-		Assert(TransactionIdPrecedesOrEquals(safeXid, snap->xmin));
-	}
-#endif
-
-	MyPgXact->xmin = snap->xmin;
-
-	/* allocate in transaction context */
-	newxip = (TransactionId *)
-		palloc(sizeof(TransactionId) * GetMaxSnapshotXidCount());
-
-	/*
-	 * snapbuild.c builds transactions in an "inverted" manner, which means it
-	 * stores committed transactions in ->xip, not ones in progress. Build a
-	 * classical snapshot by marking all non-committed transactions as
-	 * in-progress. This can be expensive.
-	 */
-	for (xid = snap->xmin; NormalTransactionIdPrecedes(xid, snap->xmax);)
-	{
-		void	   *test;
-
-		/*
-		 * Check whether transaction committed using the decoding snapshot
-		 * meaning of ->xip.
-		 */
-		test = bsearch(&xid, snap->xip, snap->xcnt,
-					   sizeof(TransactionId), xidComparator);
-
-		if (test == NULL)
-		{
-			if (newxcnt >= GetMaxSnapshotXidCount())
-				ereport(ERROR,
-						(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
-						 errmsg("initial slot snapshot too large")));
-
-			newxip[newxcnt++] = xid;
-		}
-
-		TransactionIdAdvance(xid);
-	}
-
-	snap->xcnt = newxcnt;
-	snap->xip = newxip;
+	MyPgXact->snapshotcsn = snap->snapshotcsn;
 
 	return snap;
 }
@@ -661,10 +476,10 @@ SnapBuildExportSnapshot(SnapBuild *builder)
 	snapname = ExportSnapshot(snap);
 
 	ereport(LOG,
-			(errmsg_plural("exported logical decoding snapshot: \"%s\" with %u transaction ID",
-						   "exported logical decoding snapshot: \"%s\" with %u transaction IDs",
-						   snap->xcnt,
-						   snapname, snap->xcnt)));
+			(errmsg("exported logical decoding snapshot: \"%s\" at %X/%X",
+					snapname,
+					(uint32) (snap->snapshotcsn >> 32),
+					(uint32) snap->snapshotcsn)));
 	return snapname;
 }
 
@@ -722,16 +537,7 @@ SnapBuildProcessChange(SnapBuild *builder, TransactionId xid, XLogRecPtr lsn)
 	 * We can't handle data in transactions if we haven't built a snapshot
 	 * yet, so don't store them.
 	 */
-	if (builder->state < SNAPBUILD_FULL_SNAPSHOT)
-		return false;
-
-	/*
-	 * No point in keeping track of changes in transactions that we don't have
-	 * enough information about to decode. This means that they started before
-	 * we got into the SNAPBUILD_FULL_SNAPSHOT state.
-	 */
-	if (builder->state < SNAPBUILD_CONSISTENT &&
-		TransactionIdPrecedes(xid, SnapBuildNextPhaseAt(builder)))
+	if (builder->state < SNAPBUILD_CONSISTENT)
 		return false;
 
 	/*
@@ -851,76 +657,6 @@ SnapBuildDistributeNewCatalogSnapshot(SnapBuild *builder, XLogRecPtr lsn)
 }
 
 /*
- * Keep track of a new catalog changing transaction that has committed.
- */
-static void
-SnapBuildAddCommittedTxn(SnapBuild *builder, TransactionId xid)
-{
-	Assert(TransactionIdIsValid(xid));
-
-	if (builder->committed.xcnt == builder->committed.xcnt_space)
-	{
-		builder->committed.xcnt_space = builder->committed.xcnt_space * 2 + 1;
-
-		elog(DEBUG1, "increasing space for committed transactions to %u",
-			 (uint32) builder->committed.xcnt_space);
-
-		builder->committed.xip = repalloc(builder->committed.xip,
-										  builder->committed.xcnt_space * sizeof(TransactionId));
-	}
-
-	/*
-	 * TODO: It might make sense to keep the array sorted here instead of
-	 * doing it every time we build a new snapshot. On the other hand this
-	 * gets called repeatedly when a transaction with subtransactions commits.
-	 */
-	builder->committed.xip[builder->committed.xcnt++] = xid;
-}
-
-/*
- * Remove knowledge about transactions we treat as committed that are smaller
- * than ->xmin. Those won't ever get checked via the ->committed array but via
- * the clog machinery, so we don't need to waste memory on them.
- */
-static void
-SnapBuildPurgeCommittedTxn(SnapBuild *builder)
-{
-	int			off;
-	TransactionId *workspace;
-	int			surviving_xids = 0;
-
-	/* not ready yet */
-	if (!TransactionIdIsNormal(builder->xmin))
-		return;
-
-	/* TODO: Neater algorithm than just copying and iterating? */
-	workspace =
-		MemoryContextAlloc(builder->context,
-						   builder->committed.xcnt * sizeof(TransactionId));
-
-	/* copy xids that still are interesting to workspace */
-	for (off = 0; off < builder->committed.xcnt; off++)
-	{
-		if (NormalTransactionIdPrecedes(builder->committed.xip[off],
-										builder->xmin))
-			;					/* remove */
-		else
-			workspace[surviving_xids++] = builder->committed.xip[off];
-	}
-
-	/* copy workspace back to persistent state */
-	memcpy(builder->committed.xip, workspace,
-		   surviving_xids * sizeof(TransactionId));
-
-	elog(DEBUG3, "purged committed transactions from %u to %u, xmin: %u, xmax: %u",
-		 (uint32) builder->committed.xcnt, (uint32) surviving_xids,
-		 builder->xmin, builder->xmax);
-	builder->committed.xcnt = surviving_xids;
-
-	pfree(workspace);
-}
-
-/*
  * Handle everything that needs to be done when a transaction commits
  */
 void
@@ -929,26 +665,19 @@ SnapBuildCommitTxn(SnapBuild *builder, XLogRecPtr lsn, TransactionId xid,
 {
 	int			nxact;
 
-	bool		needs_snapshot = false;
-	bool		needs_timetravel = false;
-	bool		sub_needs_timetravel = false;
+	bool		forced_timetravel = false;
 
-	TransactionId xmax = xid;
+	TransactionId xmax;
 
 	/*
-	 * Transactions preceding BUILDING_SNAPSHOT will neither be decoded, nor
-	 * will they be part of a snapshot.  So we don't need to record anything.
+	 * If we couldn't observe every change of a transaction because it was
+	 * already running at the point we started to observe we have to assume it
+	 * made catalog changes.
+	 *
+	 * This has the positive benefit that we afterwards have enough
+	 * information to build an exportable snapshot that's usable by pg_dump et
+	 * al.
 	 */
-	if (builder->state == SNAPBUILD_START ||
-		(builder->state == SNAPBUILD_BUILDING_SNAPSHOT &&
-		 TransactionIdPrecedes(xid, SnapBuildNextPhaseAt(builder))))
-	{
-		/* ensure that only commits after this are getting replayed */
-		if (builder->start_decoding_at <= lsn)
-			builder->start_decoding_at = lsn + 1;
-		return;
-	}
-
 	if (builder->state < SNAPBUILD_CONSISTENT)
 	{
 		/* ensure that only commits after this are getting replayed */
@@ -956,104 +685,45 @@ SnapBuildCommitTxn(SnapBuild *builder, XLogRecPtr lsn, TransactionId xid,
 			builder->start_decoding_at = lsn + 1;
 
 		/*
-		 * If building an exportable snapshot, force xid to be tracked, even
-		 * if the transaction didn't modify the catalog.
+		 * We could avoid treating !SnapBuildTxnIsRunning transactions as
+		 * timetravel ones, but we want to be able to export a snapshot when
+		 * we reached consistency.
 		 */
-		if (builder->building_full_snapshot)
-		{
-			needs_timetravel = true;
-		}
+		forced_timetravel = true;
+		elog(DEBUG1, "forced to assume catalog changes for xid %u because it was running too early", xid);
 	}
 
+	xmax = builder->xmax;
+
+	if (NormalTransactionIdFollows(xid, xmax))
+		xmax = xid;
+	if (!forced_timetravel)
+	{
+		if (ReorderBufferXidHasCatalogChanges(builder->reorder, xid))
+			forced_timetravel = true;
+	}
 	for (nxact = 0; nxact < nsubxacts; nxact++)
 	{
 		TransactionId subxid = subxacts[nxact];
 
-		/*
-		 * Add subtransaction to base snapshot if catalog modifying, we don't
-		 * distinguish to toplevel transactions there.
-		 */
-		if (ReorderBufferXidHasCatalogChanges(builder->reorder, subxid))
-		{
-			sub_needs_timetravel = true;
-			needs_snapshot = true;
-
-			elog(DEBUG1, "found subtransaction %u:%u with catalog changes",
-				 xid, subxid);
-
-			SnapBuildAddCommittedTxn(builder, subxid);
+		if (NormalTransactionIdFollows(subxid, xmax))
+			xmax = subxid;
 
-			if (NormalTransactionIdFollows(subxid, xmax))
-				xmax = subxid;
-		}
-
-		/*
-		 * If we're forcing timetravel we also need visibility information
-		 * about subtransaction, so keep track of subtransaction's state, even
-		 * if not catalog modifying.  Don't need to distribute a snapshot in
-		 * that case.
-		 */
-		else if (needs_timetravel)
+		if (!forced_timetravel)
 		{
-			SnapBuildAddCommittedTxn(builder, subxid);
-			if (NormalTransactionIdFollows(subxid, xmax))
-				xmax = subxid;
+			if (ReorderBufferXidHasCatalogChanges(builder->reorder, subxid))
+				forced_timetravel = true;
 		}
 	}
 
-	/* if top-level modified catalog, it'll need a snapshot */
-	if (ReorderBufferXidHasCatalogChanges(builder->reorder, xid))
-	{
-		elog(DEBUG2, "found top level transaction %u, with catalog changes",
-			 xid);
-		needs_snapshot = true;
-		needs_timetravel = true;
-		SnapBuildAddCommittedTxn(builder, xid);
-	}
-	else if (sub_needs_timetravel)
-	{
-		/* track toplevel txn as well, subxact alone isn't meaningful */
-		SnapBuildAddCommittedTxn(builder, xid);
-	}
-	else if (needs_timetravel)
-	{
-		elog(DEBUG2, "forced transaction %u to do timetravel", xid);
-
-		SnapBuildAddCommittedTxn(builder, xid);
-	}
-
-	if (!needs_timetravel)
-	{
-		/* record that we cannot export a general snapshot anymore */
-		builder->committed.includes_all_transactions = false;
-	}
-
-	Assert(!needs_snapshot || needs_timetravel);
-
-	/*
-	 * Adjust xmax of the snapshot builder, we only do that for committed,
-	 * catalog modifying, transactions, everything else isn't interesting for
-	 * us since we'll never look at the respective rows.
-	 */
-	if (needs_timetravel &&
-		(!TransactionIdIsValid(builder->xmax) ||
-		 TransactionIdFollowsOrEquals(xmax, builder->xmax)))
-	{
-		builder->xmax = xmax;
-		TransactionIdAdvance(builder->xmax);
-	}
+	builder->xmax = xmax;
+	/* We use the commit record's LSN as the snapshot */
+	builder->snapshotcsn = (CommitSeqNo) lsn;
 
 	/* if there's any reason to build a historic snapshot, do so now */
-	if (needs_snapshot)
+	if (forced_timetravel)
 	{
 		/*
-		 * If we haven't built a complete snapshot yet there's no need to hand
-		 * it out, it wouldn't (and couldn't) be used anyway.
-		 */
-		if (builder->state < SNAPBUILD_FULL_SNAPSHOT)
-			return;
-
-		/*
 		 * Decrease the snapshot builder's refcount of the old snapshot, note
 		 * that it still will be used if it has been handed out to the
 		 * reorderbuffer earlier.
@@ -1096,43 +766,20 @@ SnapBuildProcessRunningXacts(SnapBuild *builder, XLogRecPtr lsn, xl_running_xact
 	ReorderBufferTXN *txn;
 
 	/*
-	 * If we're not consistent yet, inspect the record to see whether it
-	 * allows to get closer to being consistent. If we are consistent, dump
-	 * our snapshot so others or we, after a restart, can use it.
-	 */
-	if (builder->state < SNAPBUILD_CONSISTENT)
-	{
-		/* returns false if there's no point in performing cleanup just yet */
-		if (!SnapBuildFindSnapshot(builder, lsn, running))
-			return;
-	}
-	else
-		SnapBuildSerialize(builder, lsn);
-
-	/*
 	 * Update range of interesting xids based on the running xacts
-	 * information. We don't increase ->xmax using it, because once we are in
-	 * a consistent state we can do that ourselves and much more efficiently
-	 * so, because we only need to do it for catalog transactions since we
-	 * only ever look at those.
-	 *
-	 * NB: We only increase xmax when a catalog modifying transaction commits
-	 * (see SnapBuildCommitTxn).  Because of this, xmax can be lower than
-	 * xmin, which looks odd but is correct and actually more efficient, since
-	 * we hit fast paths in tqual.c.
+	 * information.
 	 */
 	builder->xmin = running->oldestRunningXid;
+	builder->xmax = running->nextXid;
+	builder->snapshotcsn = (CommitSeqNo) lsn;
 
-	/* Remove transactions we don't need to keep track off anymore */
-	SnapBuildPurgeCommittedTxn(builder);
-
-	elog(DEBUG3, "xmin: %u, xmax: %u, oldestrunning: %u",
-		 builder->xmin, builder->xmax,
-		 running->oldestRunningXid);
+	elog(DEBUG3, "xmin: %u, xmax: %u",
+		 builder->xmin, builder->xmax);
+	Assert(lsn != InvalidXLogRecPtr);
 
 	/*
-	 * Increase shared memory limits, so vacuum can work on tuples we
-	 * prevented from being pruned till now.
+	 * Increase shared memory limits, so vacuum can work on tuples we prevented
+	 * from being pruned till now.
 	 */
 	LogicalIncreaseXminForSlot(lsn, running->oldestRunningXid);
 
@@ -1148,12 +795,8 @@ SnapBuildProcessRunningXacts(SnapBuild *builder, XLogRecPtr lsn, xl_running_xact
 	 * beginning. That point is where we can restart from.
 	 */
 
-	/*
-	 * Can't know about a serialized snapshot's location if we're not
-	 * consistent.
-	 */
 	if (builder->state < SNAPBUILD_CONSISTENT)
-		return;
+		builder->state = SNAPBUILD_CONSISTENT;
 
 	txn = ReorderBufferGetOldestTXN(builder->reorder);
 
